#import "SavePanelWithPopUp.h"

@implementation SavePanelWithPopUp
+ _factory
{
    return [self class];
}

+ newContent:(const NXRect *)contentRect style:(int)aStyle
	backing:(int)bufferingType buttonMask:(int)mask defer:(BOOL)flag
{
	SavePanelWithPopUp* panel;

	panel = [SavePanel newContent:contentRect style:aStyle
			backing:bufferingType buttonMask:mask defer:flag];
	return [panel setUp];
}

- setUp
{	
	types = [[Storage alloc] init];
	popUp = [[PopUpList alloc] init];
	[popUp setTarget: self];
	[popUp setAction: sel_getUid("changeTypes")];
//printf("End SETUP\n");

	return self;
}
- registerPopUp
{
	[super setAccessoryView: NXCreatePopUpListButton(popUp)];
	return self;
}
- addType:(char*)type withDescription:(char*)description
{
 int len = strlen(type) + strlen(description);
 char* str = malloc(sizeof(char)*(len+4));
 char* ft = malloc((strlen(type)+1)*sizeof(char));

 strcpy(ft,type);
 ft[strlen(type)] = '\0';
 strcpy(str,type);
 strcat(str," - ");
 strcat(str,description);
 str[len+3] = '\0';
 [popUp addItem: str];
 [types addElement: ft];
 if(!selectedType)
	{
	 selectedType = [types elementAt:0];
	 [self setRequiredFileType: selectedType];
	}
// free(ft);		//	???
 free(str);
 return self;
}

- (int)runModal
{
	return [super runModal];
}

- changeTypes
{
	selectedType = [types elementAt: [[popUp itemList] selectedRow]];
	[self setRequiredFileType: selectedType];
//printf("%i,%s\n",[[popUp itemList] selectedRow],selectedType);
	return self;
}

- (char*)selectedType
{
	return selectedType;
}
@end